import pygame as pg
import geometry as g

import canvas as c
import math

WINDOW_WIDTH = 1200
WINDOW_HEIGHT = 800

# -------------------------------------------------------------------
#
# Initialize PyGame
#
# -------------------------------------------------------------------

pg.init()
main_window = pg.display.set_mode((WINDOW_WIDTH, WINDOW_HEIGHT))
# set Title of window
pg.display.set_caption("Test Canvas")
pg.font.init()


l1 = g.Line(g.Point(0, 0), g.Point(100, 100))
t1 = g.Triangle(g.Point(100, 100), g.Point(200, 200), g.Point(300, 100))
r1 = g.Rectangle(g.Point(300, 100), g.Point(500, 0))
c1 = g.Circle(g.Point(200, 200), 100)
p1 = g.Polygon(
    [
        g.Point(0, 0),
        g.Point(-100, 20),
        g.Point(-100, 60),
        g.Point(
            0,
            40,
        ),
        g.Point(100, 60),
        g.Point(100, 20),
    ]
)


#
# Affichage de formes avec canvas et transformations
#

print("Test affichage Canvas dans une fenêtre ", WINDOW_WIDTH, "x", WINDOW_HEIGHT)
print("Appuyez sur 'Esc' pour quitter")

canvas = c.Canvas(main_window, WINDOW_WIDTH // 2, WINDOW_HEIGHT // 2, 1)
rotation = g.Rotation(math.pi / 4)
translation = g.Translation(g.Point(50, 10))

print("FIRST WINDOW")

green = (0, 255, 0)
red = (255, 0, 0)

angle = 0
done = False
while not done:
    pg.time.delay(65)
    main_window.fill((0, 0, 0))

    transformation = g.Rotation(angle)

    canvas.draw_axis()

    l1_drawn = canvas.draw_line(l1, green, [transformation])
    canvas.draw_bounding_box(l1_drawn.get_bounding_box(), red)

    t1_drawn = canvas.draw_triangle(t1, green, [transformation])
    canvas.draw_bounding_box(t1_drawn.get_bounding_box(), red)

    r1_drawn = canvas.draw_rectangle(r1, green, [transformation])
    canvas.draw_bounding_box(r1_drawn.get_bounding_box(), red)

    c1_drawn = canvas.draw_circle(c1, green, [transformation])
    canvas.draw_bounding_box(c1_drawn.get_bounding_box(), red)

    p1_drawn = canvas.draw_polygon(p1, green, [transformation])
    canvas.draw_bounding_box(p1_drawn.get_bounding_box(), red)

    canvas.draw_text("Press Esc to quit", 10, 200, (255, 255, 0))

    pg.display.update()

    angle = angle + 0.05

    for event in pg.event.get():
        if event.type == pg.constants.KEYDOWN:
            if event.key == pg.constants.K_ESCAPE:
                done = True

print("Line         : " + str(l1))
print("Line drawn   : " + str(l1_drawn))
print("Line drawn bb: " + str(l1_drawn.get_bounding_box()))
